



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS---iOS9搜索功能</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS---iOS9搜索功能</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 21:05:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>前言</h2>
<p>在iOS9之前我们只能使用Spotlight来搜索应用名称来打开指定App，而其他的内容都是提供给系统使用(信息，联系人，邮件等)。在iOS9以后Apple允许开发者设置应用中任意内容可以被Spotlight索引到以及用户在选择了搜索内容时会发生什么。如demo所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/785702/201508/042214482674850.png" /></p>
<p>图1&nbsp;Spotlight搜索应用内结果示意图</p>
<div>
<h2>简单介绍</h2>
</div>
<p>在iOS9中提供了三种API来帮助我们实现搜索，如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/785702/201508/042218091892501.png" /></p>
<p>图2 iOS 9新增搜索API</p>
<h3>NSUserActivity</h3>
<p>NSUserActivity包含了一些新的方法和属性来帮助我们实现索引activities和应用状态使他们在搜索结果中可用。每一个应用都可以利用NSUserActivity API来生成对于用户来说更有用的内容。顺便提一句NSUserActivity在iOS8中的Handoff就已经被引入了。</p>
<h3>Web Markup</h3>
<p>这一特性允许应用镜像自己的内容，并在Spotlight中建立自己的引用。苹果的爬虫会抓取你的网站上打了markup的内容，而这些内容会提供给Safari和Spotlight。这个特性的神奇之处在于。用户不需要将你的应用安装在手机上。这样你的应用可以更多的展示给潜在用户。苹果的云服务会索引你的内容，让你的应用与Public Search API保持深度的链接会让你收益颇多。</p>
<h3>Core Spotlight</h3>
<p>新的CoreSpotlight(framework)是iOS9提供的一组新的API来帮助你建立起你的应用中的索引。CoreSpotlight是用来处理用户数据的比如：文档，照片以及其他类型的由用户产生的内容。</p>
<div>
<h2>让我们开始吧</h2>
</div>
<h3>准备工作</h3>
<p>首先我们使用三个不同的ViewController来加载不同的用户数据:</p>
<ul><li>Image</li>
<li>TXT</li>
<li>Web</li></ul>
<p>然后使用一个TableView用来索引他们这一部分的代码就不赘述具体结构如图</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/785702/201508/042228378618302.png" /></p>
<p>图3 Demo 初始化</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/785702/201508/042230246261653.png" /></p>
<p>图4 iPhone &nbsp;Demo截图</p>
<p>好，万事具备，只欠CoreSpotlight啦</p>
<h3>CoreSpotlight</h3>
<p>先将framework导入<br />工程-&gt;Build Phases-&gt;Link Binary With Libraries-&gt;搜索CoreSpotlight<br />如果搜索不到请确认自己使用的是Xcode7</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/785702/201508/042232183457811.png" /></p>
<p>图 5 添加CoreSpotlight框架</p>
<p>接下来就是最重要的代码部分了</p>
<p>首先，导入头文件</p>
<div>
<pre class="prettyprint linenums">#import &lt;CoreSpotlight/CoreSpotlight.h&gt; </pre>
</div>
<p>然后将需要索引的数据保存至CoreSpotlight</p>
<div>
<pre class="prettyprint linenums">- (void)saveData{&nbsp;&nbsp;&nbsp;<br />   &nbsp; NSMutableArray *seachableItems = [NSMutableArray new];&nbsp;&nbsp;&nbsp;<br />   &nbsp; [self.tableData enumerateObjectsUsingBlock:^(NSString *__nonnull obj, NSUInteger idx, BOOL * __nonnull stop) {&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />        &nbsp; CSSearchableItemAttributeSet *attributeSet = [[CSSearchableItemAttributeSet alloc] initWithItemContentType:@"views"];&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />        &nbsp; attributeSet.title = obj;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />      &nbsp;&nbsp;&nbsp; attributeSet.contentDescription = [NSString stringWithFormat:NSLocalizedString(@"a easy way to open %@", nil),obj];&nbsp;<br />  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; UIImage *thumbImage = [UIImage imageNamed:[NSString stringWithFormat:@"icon_%@.png",obj]];<br /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; attributeSet.thumbnailData = UIImagePNGRepresentation(thumbImage);//beta 1 there is a bug&nbsp;<br /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; CSSearchableItem *item = [[CSSearchableItem alloc] initWithUniqueIdentifier:obj&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;                                                                                                                                                                      domainIdentifier:@"com.kdanmobile.CoreSpotlightDemo"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;                                                                                                               attributeSet:attributeSet];<br /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; [seachableItems addObject:item];&nbsp;&nbsp;&nbsp;&nbsp;<br />       }];<br />&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;[[CSSearchableIndex defaultSearchableIndex] indexSearchableItems:seachableItems<br />   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; completionHandler:^(NSError * __nullable error) {&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if (!error)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />                  &nbsp;NSLog(@"%@",error.localizedDescription);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />      &nbsp; }];<br />  }&nbsp;&nbsp; </pre>
</div>
<p>执行下程序然后到Spotlight查看是否有保存进去</p>
<p>如果没保存进去不要紧，尝试重启下模拟器再到Spotlight中查看应该就有了。这应该事Xcode的一个bug<br />另外关于CSSearchableItemAttributeSet的各个属性的含义如下图所示</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/785702/201508/042236213149216.png" /></p>
<p>图 6 Demo Spotlight搜索示意图</p>
<p>现在我们点击搜索到相应的项还只能打开我们的应用，如果要实现跳转还需要进行一小步的工作：在AppDelegate中实现</p>
<p>- (BOOL)application:(nonnull UIApplication *)application continueUserActivity:(nonnull NSUserActivity *)userActivity restorationHandler:(nonnull void (^)(NSArray * __nullable))restorationHandler{</p>
<p>NSString *idetifier = userActivity.userInfo[@"kCSSearchableItemActivityIdentifier"];</p>
<p>UINavigationController *navigationController = (UINavigationController *)self.window.rootViewController;</p>
<p>[navigationController popToRootViewControllerAnimated:YES];</p>
<p>CoreSpotlightTableViewController *coreViewController = [[navigationController viewControllers] firstObject];</p>
<p>[coreViewController showViewControllerWithIdentifier:idetifier];</p>
<p>return YES;</p>
<p>}</p>
<p>而在实现这个方法后在点击spotlight中点击相应的项就会跳转到我们相应的ViewController中啦</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/785702/201508/042238436426968.png" /></p>
<p>图7 Demo Spolight 搜索截图</p>
<p>最后需要提到的就是索引的删除。CoreSpotlight给我们提供了三个方法来进行删除分别是：</p>
<div>
<pre class="prettyprint linenums">- (void)deleteSearchableItemsWithIdentifiers:(NSArray&lt;NSString *&gt; *)identifiers completionHandler:(void (^ __nullable)(NSError * __nullable error))completionHandler; 

- (void)deleteSearchableItemsWithDomainIdentifiers:(NSArray&lt;NSString *&gt; *)domainIdentifiers completionHandler:(void (^ __nullable)(NSError * __nullable error))completionHandler;

 - (void)deleteAllSearchableItemsWithCompletionHandler:(void (^ __nullable)(NSError * __nullable error))completionHandler; </pre>
</div>
<p>根据identifier来删除，根据domain来删除以及删除所有的索引。<br />从Xcode7自动补全的代码看来出现了很多以前不常见的代码如:nonnull , __nullable,NSArray&lt;NSString *&gt;,等，其中nonull在Xcode6的某个版本往后就提供了。目的是用来更好的与swift中的optional变量连接。从这些看来以后苹果的重心将慢慢往swift转移。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zoz1nq.html">git&colon; 常用功能等</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8md1n28.html">2016最新 wamp2&period;5&plus;windows 10安装CoedSgniffer代码格式检查：5分钟安装 30分钟入门和浏览常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7gme1q.html">Android性能测试工具APT使用指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m16l28.html">IOS开发--常用工具类收集整理（Objective-C）（持续更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydrn02q.html">网络请求的null值处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5p7v8.html">bzoj2535 2109</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1g6628.html">js给数字加三位一逗号间隔的两种方法（面试题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmrvz49.html">HDFS的shell操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6wd3q.html">hdu 5443 The Water Problem 线段树</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1z1l39.html">Python自动化运维之20、HTML</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1pwe38.html">android如何保存读取读取文件文件保存到SDcard</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj1v6x9.html">&amp;lt&semi;T&amp;gt&semi; List&amp;lt&semi;T&amp;gt&semi;前面&amp;lt&semi;T&amp;gt&semi;的意思</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzx2pe8.html">自学Zabbix3&period;9&period;3-模板Templates-嵌套Nesting</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mexk4rq.html">javascript-发布订阅模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj0pd09.html">Oracle导出表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv20kz19.html">PL&bsol;SQL 随学笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o30218.html">《Linux内核》第七周 进程的切换和系统的一般执行过程 20135311傅冬菁</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyzydn9.html">Codeforces 781D Axel and Marston in Bitland</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlwr4z9.html">&lbrack;翻译&rsqb;NUnit---Sequential and SetCulture and SetUICulture Attributes&lpar;十八&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp20vy9.html">1014 C语言文法定义</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/g8ey6nz9.html">UGUI全面实践教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8eygyz9.html">MVC Html&period;BeginForm 与 Ajax&period;BeginForm 使用总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zozlvq.html">BZOJ 2152 &amp;amp&semi; 点分治</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oj6rlq.html">Git Commands Quick Notes</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlj4v09.html">Asp&period;Net Mvc &plus; ComBoost&period;Mvc快速开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnjoo38.html">Shader实例&colon;扭曲，漩涡</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96pvn48.html">bootstrap之伪元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4zrre9.html">tcpdum使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pdzv79.html">div样式text-align在子元素缩进不规范的情况下，chrome出现的问题（貌似结果是inline-block导致的）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96p1vn8.html">zend studio8编辑器乱码问题解决办法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
